
#import "MyDeviceViewController.h"
#import "NetDEVSDK.h"
#import "PlaybackViewController.h"
#import "LocalLoginViewController.h"
#import "common.h"

LPVOID  lpUserID;  //User ID
LPVOID lpCloudUserID;  //Cloud User ID
extern INT32 gdwChlID;
extern int gdwLoginDeviceType;
extern NETDEMO_DEV_LOGININFO_S gastLoginDeviceInfo;

NSString* strDeviceSN;
extern BOOL isbNoaccountFlag;

@interface MyDeviceViewController ()

@end

@implementation MyDeviceViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}



/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

/* Login cloud account */
- (IBAction)LoginDevice:(id)sender
{
    char *pszUsername = (char*)[_DeviceName.text UTF8String];
    
    /* judging device type, VMS device modle shoule contains ""VMS */
    for(int i = 0; i < gastLoginDeviceInfo.dwCloudDevNum; i++)
    {
        if(!strcmp(gastLoginDeviceInfo.stCloudDevBaseInfo[i].szDevUserName, pszUsername))
        {
            NSString *NSDevModle = [NSString stringWithUTF8String:gastLoginDeviceInfo.stCloudDevBaseInfo[i].szDevModel];
            if([NSDevModle rangeOfString:@"VMS"].location != NSNotFound)
            {
                gdwLoginDeviceType = 1;
                break;
            }
        }
    }
    
    NETDEV_CLOUD_DEV_LOGIN_INFO_S stCloudInfo = {0};
    strncpy(stCloudInfo.szDeviceName, pszUsername, sizeof(stCloudInfo.szDeviceName) -1);
    stCloudInfo.dwConnectMode = NETDEV_CLOUD_CONNECT_MODE_P2P;
    stCloudInfo.dwT2UTimeout = 15;
    
    if(1 == gdwLoginDeviceType)  /* VMS device */
    {
        stCloudInfo.dwLoginProto = NETDEV_LOGIN_PROTO_PRIVATE;
        
    }
    
    lpUserID = NETDEV_LoginCloudDevice_V30(lpCloudUserID, &stCloudInfo);
    if(NULL == lpUserID)
    {
        stCloudInfo.dwConnectMode = NETDEV_CLOUD_CONNECT_MODE_TURN;
        lpUserID = NETDEV_LoginCloudDevice_V30(lpCloudUserID, &stCloudInfo);
    }

    if(NULL == lpUserID)
    {
        NSLog(@"devLogin Failed, please check your username, password and port.");
        return;
    }
    else
    {
        NSLog(@"devLogin success");
        dispatch_async(dispatch_get_global_queue(0, 0), ^{
            /* register exception callback */
            BOOL bRet = NETDEV_SetExceptionCallBack(NETDEV_ExceptionCallBack, 0);
            if(TRUE != bRet)
            {
                NSLog(@"register exception callback Failed ");
            }
            else
            {
                NSLog(@"register exception callback Success");
            }
            
            bRet = NETDEV_SetAlarmCallBack_V30(lpUserID, NETDEV_AlarmMessCallBackV30, 0);
            if(TRUE != bRet)
            {
                NSLog(@"NETDEV_SetAlarmCallBack_V30 Failed ");
            }
            else
            {
                NSLog(@"NETDEV_SetAlarmCallBack_V30 Success");
            }
            
            
            NSLog(@"currentThread:%@", [NSThread currentThread]);
        });

        [self gotoMain];
        return;
    }
}

- (void)gotoMain
{
    MainViewController *pViewCtrl = [self.storyboard instantiateViewControllerWithIdentifier:@"Tab"];
    UINavigationController *pNavCtrol = [[UINavigationController alloc] initWithRootViewController:pViewCtrl];
    
    [self presentViewController:pNavCtrol animated:YES completion:nil];
}



/*Get device List*/
- (IBAction)FindDevice:(id)sender
{
    LPVOID lpFileHandle = 0;
    
    lpFileHandle = NETDEV_FindCloudDevListEx(lpCloudUserID);  //Query device list under a cloud account
    if(NULL == lpFileHandle)
    {
        NSLog(@"Query failed.");
        return;
    }
    else
    {
        NETDEV_CLOUD_DEV_BASIC_INFO_S stDevInfo = {0};
        gastLoginDeviceInfo.dwCloudDevNum = 0;
        while(TRUE == NETDEV_FindNextCloudDevInfoEx(lpFileHandle, &stDevInfo))
        {
            NSLog(@"DEV Name%d: \t %s\n", gastLoginDeviceInfo.dwCloudDevNum  , stDevInfo.szDevName);
            NSLog(@"DevUser Name%d: \t %s\n", gastLoginDeviceInfo.dwCloudDevNum  , stDevInfo.szDevUserName);
            gastLoginDeviceInfo.stCloudDevBaseInfo[gastLoginDeviceInfo.dwCloudDevNum] = stDevInfo;
            gastLoginDeviceInfo.dwCloudDevNum++;
        }
        NETDEV_FindCloseCloudDevListEx(lpFileHandle);
            
            
//        NETDEV_CLOUD_DEV_BASIC_INFO_S stDevInfo = {0};
//        for(INT32 i = 0; i < 10; i++)
//        {
//            BOOL bRet = NETDEV_FindNextCloudDevInfoEx(lpFileHandle, &stDevInfo);//Obtain information about detected devices one by one
//
//            if(TRUE != bRet)
//            {
//                break;
//            }
//            else
//            {
//                NSLog(@"DEV Name%d: \t %s\n", i , stDevInfo.szDevName);
//                NSLog(@"DevUser Name%d: \t %s\n", i , stDevInfo.szDevUserName);
//            }
//        }
    }
    
    //NETDEV_FindCloseCloudDevListEx(lpFileHandle);
}
/*Logout*/
- (IBAction)Logout:(id)sender
{
    if(TRUE == isbNoaccountFlag)
    {
        NETDEV_CLOUD_NOACCOUNT_INFO_S stNoAccountInfo = {0};
        strncpy(stNoAccountInfo.szDeviceSN, [strDeviceSN UTF8String], sizeof(stNoAccountInfo.szDeviceSN) -1);
        BOOL bRet = NETDEV_NoAccountCancel(lpCloudUserID, &stNoAccountInfo);
        if(TRUE != bRet)
        {
            NSLog(@"NETDEV_NoAccountCancel Failed ");
        }
        else
        {
            NSLog(@"NETDEV_NoAccountCancel Success");
        }
    }
        
        
    if(TRUE != NETDEV_Logout(lpUserID))
    {
        NSLog(@"NETDEV_Logout failure");
    }
    else
    {
        NSLog(@"NETDEV_Logout success");
    }
    gdwLoginDeviceType = 0;
    
    [self.navigationController dismissViewControllerAnimated:YES completion:nil];
}

- (IBAction)KeyBDMiss:(id)sender
{
    [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
}

/* Get Device Channel Information */
- (IBAction)GetDeviceChlInfo:(id)sender
{
    BOOL bRet = FALSE;
    if(NULL == lpUserID)
    {
        return;
    }
    
    NETDEV_DEVICE_BASICINFO_S stDeviceInfo = {0};
    INT32 dwOutBufferSize = sizeof(stDeviceInfo);
    
    bRet = NETDEV_GetDevConfig(lpUserID, gdwChlID, NETDEV_GET_DEVICECFG , &stDeviceInfo, dwOutBufferSize, &dwOutBufferSize);
    
    if(TRUE != bRet)
    {
        NSLog(@"Get Device Info Failed ");
    }
    else
    {
        NSLog(@"Get Device Info Success");
       
        printf("DevName: %s, DevAdd: %s, DevModel: %s, FirmwareVersion:%s, DevSerailNum: %s",stDeviceInfo.szDeviceName, stDeviceInfo.szMacAddress,stDeviceInfo.szDevModel,stDeviceInfo.szFirmwareVersion,stDeviceInfo.szSerialNum);
       
    }

}

/* Delete cloud devices */
- (IBAction)btn_DelDevice:(UIButton *)sender {
    char *pszDevUserName = (char*)[_DeviceName.text UTF8String];
    BOOL ret = FALSE;
    if(TRUE == strcmp(pszDevUserName, ""))
    {
        NSLog(@"Device RegisterCode is NULL, Please input RegisterCode!");
        return;
    }
    ret = NETDEV_DeleteCloudDevice(lpCloudUserID, pszDevUserName);
    if(TRUE == ret)
    {
        NSLog(@"NETDEV_DeleteCloudDevice succeed!");
    }
    else
    {
        NSLog(@"NETDEV_DeleteCloudDevice failed!");
    }
}

/* Add cloud devices */
- (IBAction)btn_AddDevice:(UIButton *)sender {
    char *pszDevRegisterCode = (char*)[_DeviceName.text UTF8String];
    BOOL ret = FALSE;
    if(TRUE == strcmp(pszDevRegisterCode, ""))
    {
        NSLog(@"Device RegisterCode is NULL, Please input RegisterCode!");
        return;
    }
    
    NETDEV_CLOUD_DEV_BASE_INFO_S stDevBase = {0};
    ret = NETDEV_AddCloudDevice(lpCloudUserID, pszDevRegisterCode, "deviceaaaa", &stDevBase);
    if(TRUE == ret)
    {
        NSLog(@"NETDEV_AddCloudDevice succeed!");
    }
    else
    {
        NSLog(@"NETDEV_AddCloudDevice failed!");
    }
}
- (IBAction)btn_LoginByRegisterCode:(id)sender {
    char *pszRegisterCode = (char*)[_RegisterCodeEdit.text UTF8String];
    char *pszUserName =      (char*)[_UserNameEdit.text UTF8String];
    char *pszPassword = (char*) [_DevicePassword.text UTF8String];
    
    if(0 == strcmp("",pszRegisterCode) || 0 == strcmp("",pszUserName) || 0 == strcmp("",pszPassword))
    {
        NSLog(@"LoginByRegisterCode failed!");
        return;
    }
    
    /*Login cloud device*/
    NETDEV_LOGIN_INFO_S stLoginInfo = {0};
    NETDEV_CLOUD_DEV_LOGIN_INFO_S stCloudDevLoginInfo = {0};
    stLoginInfo.pstCloudInfo = &stCloudDevLoginInfo;
    stLoginInfo.pstCloudInfo->dwConnectMode = 2;
    stLoginInfo.pstCloudInfo->dwT2UTimeout = 15;
    stLoginInfo.lpUserID = lpCloudUserID;
    strncpy(stLoginInfo.szRegisterCode, pszRegisterCode, sizeof(stLoginInfo.szRegisterCode) -1);
    strncpy(stLoginInfo.szUserName, pszUserName, sizeof(stLoginInfo.szUserName) -1);
    strncpy(stLoginInfo.szPassword, pszPassword, sizeof(stLoginInfo.szPassword) -1);
    
    stLoginInfo.LoginType = NETDEV_LOGIN_TYPE_CLOUD_DEVICE_SN;
    lpUserID = NETDEV_LoginV2(&stLoginInfo);
    if(NULL == lpUserID)
    {
        stLoginInfo.pstCloudInfo->dwConnectMode = 3;
        lpUserID = NETDEV_LoginV2(&stLoginInfo);
    }

    
    if(NULL == lpUserID)
    {
        NSLog(@"devLogin Failed, please check your username, password and port.");
        return;
    }
    else
    {
        NSLog(@"devLogin success");
        dispatch_async(dispatch_get_global_queue(0, 0), ^{
            /* register exception callback */
            BOOL bRet = NETDEV_SetExceptionCallBack(NETDEV_ExceptionCallBack, 0);
            if(TRUE != bRet)
            {
                NSLog(@"register exception callback Failed ");
            }
            else
            {
                NSLog(@"register exception callback Success");
            }
            
            /* register alarm callback */
            NETDEV_ALARM_SUB_INFO_S stSubscribeInfo = {0};
            stSubscribeInfo.dwAlarmType = NETDEV_SUBSCRIBE_ALARM_TYPE_COM;
            bRet = NETDEV_SetAlarmCallBack_V30(lpUserID, NETDEV_AlarmMessCallBackV30, 0);
            if(TRUE != bRet)
            {
                NSLog(@"register alarm callback Failed ");
            }
            else
            {
                NSLog(@"register alarm callback Success");
            }
            
            strDeviceSN = [NSString stringWithUTF8String:stLoginInfo.szDeviceSN];
            NETDEV_CLOUD_NOACCOUNT_INFO_S stNoAccountInfo = {0};
            strncpy(stNoAccountInfo.szDeviceName,"TestDevice",sizeof(stNoAccountInfo.szDeviceName) - 1);
            strncpy(stNoAccountInfo.szDeviceSN,stLoginInfo.szDeviceSN,sizeof(stNoAccountInfo.szDeviceSN) - 1);
            
            bRet = NETDEV_NoAccountBinding(lpCloudUserID, &stNoAccountInfo);
            if(TRUE != bRet)
            {
                NSLog(@"NETDEV_NoAccountBinding Failed ");
            }
            else
            {
                NSLog(@"ETDEV_NoAccountBinding Success");
            }
            
            NSLog(@"currentThread:%@", [NSThread currentThread]);
        });
        
        [self gotoMain];
        return;
    }
}
@end
