 //
//  ViewController.m
//  demo
//


#import "ViewController.h"
#import "PlaybackViewController.h"
#import "AlarmInfoViewController.h"
#import "NetDEVSDK.h"

//LPVOID  lpUserID;//User ID
LPVOID lpCloudUserID;//Cloud User ID

BOOL isbNoaccountFlag;

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/* Go to master page */
- (void)gotoMain
{
    MainViewController *pViewCtrl = [self.storyboard instantiateViewControllerWithIdentifier:@"Tab"];
   UINavigationController *pNavCtrol = [[UINavigationController alloc] initWithRootViewController:pViewCtrl];
    
   [self presentViewController:pNavCtrol animated:YES completion:nil];
}

/* Click the blank space to remove the virtual keyboard */
- (IBAction)dismissKeyboard:(id)sender
{
   [[[UIApplication sharedApplication] keyWindow] endEditing:YES];
}



/*
    Cloud access can be divided into four steps:
    1、Ensure devices exist under cloud account；
    2、Log into cloud account；
    3、Find cloud device info；
    4、Log in to device with device username/password (device password is not required if login with dynamic.
 
 */

/*Login to cloud account*/
- (IBAction)CloudLoginSender:(id)sender
{
    
    [self.view endEditing:YES];
    char *pszIPAddr = (char*)[_txtIp.text UTF8String];
    char *pszUserName = (char*)[_txtUser.text UTF8String];
    char *pszPassword = (char*) [_txtPass.text UTF8String];
    
   isbNoaccountFlag = FALSE;
    if(0 == strcmp("",pszUserName) && 0 == strcmp("",pszPassword))
    {
        isbNoaccountFlag = TRUE;
    }
    lpCloudUserID = NETDEV_LoginCloudEx(pszIPAddr, pszUserName , pszPassword, isbNoaccountFlag);
    if(NULL == lpCloudUserID)
    {
        NSLog(@"CloudLogin Failed, please check your username, password and port.");
        return;
    }
    
        NSLog(@"CloudLogin success.");
    
    NETDEV_CLOUD_MOBILE_INFO_S stMobileInfo = {0};
    NETDEV_CLOUD_LIMIT_INFO_S stCloudLimitInfo = {0};
    
    stMobileInfo.bDonotDisturb = TRUE;
    stMobileInfo.bIosEnvir = TRUE;
    stMobileInfo.bPushBuiltFlag = FALSE;
    
    NSUserDefaults *defs = [NSUserDefaults standardUserDefaults];
    NSArray *languages = [defs objectForKey:@"AppleLanguages"];
    NSString *prefrenceLanguage = [languages objectAtIndex:0];
    strncpy(stMobileInfo.szAppLanguage, [prefrenceLanguage UTF8String], sizeof(stMobileInfo.szAppLanguage) -1);
    strncpy(stMobileInfo.szAppName, "NetDemo", sizeof(stMobileInfo.szAppName) -1);
    strncpy(stMobileInfo.szAppVersion, "2.1.0.0", sizeof(stMobileInfo.szAppVersion) -1);
    strncpy(stMobileInfo.szMobileModule, "iPhone6", sizeof(stMobileInfo.szMobileModule) -1);
    strncpy(stMobileInfo.szSystemType, "ios", sizeof(stMobileInfo.szSystemType) -1);
    
    NSString *systemVersion = [[UIDevice currentDevice]systemVersion];
    NSString *mobileVewsion = [NSString stringWithFormat:@"ios%@", systemVersion];
    strncpy(stMobileInfo.szSystemVersion, [mobileVewsion UTF8String], sizeof(stMobileInfo.szSystemVersion) -1);
    
    BOOL bRet = NETDEV_ReportMobileInfo(lpCloudUserID, &stMobileInfo, &stCloudLimitInfo);
    if(TRUE != bRet)
    {
        NSLog(@"NETDEV_ReportMobileInfo failure:error:%d",NETDEV_GetLastError());
    }
    else
    {
        NSLog(@"NETDEV_ReportMobileInfo success");
    }
    
}



@end
